require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FENV_H_)) {
    eval 'sub _FENV_H_ () {1;}' unless defined(&_FENV_H_);
    require 'sys/_types.ph';
    unless(defined(&__fenv_static)) {
	eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
    }
    eval 'sub FE_INVALID () {0x10;}' unless defined(&FE_INVALID);
    eval 'sub FE_DIVBYZERO () {0x8;}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_OVERFLOW () {0x4;}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_UNDERFLOW () {0x2;}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_INEXACT () {0x1;}' unless defined(&FE_INEXACT);
    eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW);}' unless defined(&FE_ALL_EXCEPT);
    eval 'sub _ROUND_SHIFT () {5;}' unless defined(&_ROUND_SHIFT);
    eval 'sub FE_TONEAREST () {(0x <<  &_ROUND_SHIFT);}' unless defined(&FE_TONEAREST);
    eval 'sub FE_TOWARDZERO () {(0x1 <<  &_ROUND_SHIFT);}' unless defined(&FE_TOWARDZERO);
    eval 'sub FE_DOWNWARD () {(0x2 <<  &_ROUND_SHIFT);}' unless defined(&FE_DOWNWARD);
    eval 'sub FE_UPWARD () {(0x3 <<  &_ROUND_SHIFT);}' unless defined(&FE_UPWARD);
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_DOWNWARD |  &FE_UPWARD |  &FE_TOWARDZERO);}' unless defined(&_ROUND_MASK);
    eval 'sub FE_DFL_ENV () {(& &__fe_dfl_env);}' unless defined(&FE_DFL_ENV);
    if(!defined(&__riscv_float_abi_soft)  && !defined(&__riscv_float_abi_double)) {
	if(defined(&__riscv_float_abi_single)) {
	    die("single\ precision\ floating\ point\ ABI\ not\ supported");
	} else {
	    die("compiler\ did\ not\ set\ soft\/hard\ float\ macros");
	}
    }
    unless(defined(&__riscv_float_abi_soft)) {
	eval 'sub __rfs {
	    my($__fcsr) = @_;
    	    eval q( &__asm  &__volatile(\\"csrr %0, fcsr\\" : \\"=r\\" ($__fcsr)));
	}' unless defined(&__rfs);
	eval 'sub __wfs {
	    my($__fcsr) = @_;
    	    eval q( &__asm  &__volatile(\\"csrw fcsr, %0\\" :: \\"r\\" ($__fcsr)));
	}' unless defined(&__wfs);
    }
    if(defined(&__riscv_float_abi_soft)) {
    } else {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	if(defined(&__riscv_float_abi_soft)) {
	} else {
	}
    }
}
1;
