require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    require 'sys/atomic_common.ph';
    eval 'sub fence () {
        eval q( &__asm  &__volatile(\\"fence\\" ::: \\"memory\\"););
    }' unless defined(&fence);
    eval 'sub mb () {
        eval q( &fence());
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &fence());
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &fence());
    }' unless defined(&wmb);
    eval 'sub atomic_subtract_32 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoadd.w zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" (-$val) : \\"memory\\"); });
    }' unless defined(&atomic_subtract_32);
    eval 'sub atomic_set_32 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoor.w zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); });
    }' unless defined(&atomic_set_32);
    eval 'sub atomic_clear_32 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoand.w zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" (~$val) : \\"memory\\"); });
    }' unless defined(&atomic_clear_32);
    eval 'sub atomic_cmpset_32 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint32_t  &tmp; \'int\'  &res;  &res = 0;  &__asm  &__volatile( \\"0:\\" \\"li   %1, 1\\\\n\\" \\"lr.w %0, %2\\\\n\\" \\"bne  %0, %z3, 1f\\\\n\\" \\"sc.w %1, %z4, %2\\\\n\\" \\"bnez %1, 0b\\\\n\\" \\"1:\\" : \\"=&r\\" , \\"=&r\\" , \\"+A\\" (*$p) : \\"rJ\\" (( &int32_t)$cmpval), \\"rJ\\" ($newval) : \\"memory\\"); (! &res); });
    }' unless defined(&atomic_cmpset_32);
    eval 'sub atomic_fcmpset_32 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint32_t  &tmp; \'int\'  &res;  &res = 0;  &__asm  &__volatile( \\"0:\\" \\"li   %1, 1\\\\n\\" \\"lr.w %0, %2\\\\n\\" \\"bne  %0, %z4, 1f\\\\n\\" \\"sc.w %1, %z5, %2\\\\n\\" \\"j 2f\\\\n\\" \\"1:\\" \\"sw   %0, %3\\\\n\\" \\"2:\\" : \\"=&r\\" , \\"=&r\\" , \\"+A\\" (*$p), \\"+A\\" (*$cmpval) : \\"rJ\\" (( &int32_t)*$cmpval), \\"rJ\\" ($newval) : \\"memory\\"); (! &res); });
    }' unless defined(&atomic_fcmpset_32);
    eval 'sub atomic_fetchadd_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &ret;  &__asm  &__volatile(\\"amoadd.w %0, %2, %1\\" : \\"=&r\\" ( &ret), \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_fetchadd_32);
    eval 'sub atomic_readandclear_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &ret;  &uint32_t  &val;  &val = 0;  &__asm  &__volatile(\\"amoswap.w %0, %2, %1\\" : \\"=&r\\"( &ret), \\"+A\\" (*$p) : \\"r\\" ( &val) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_add_int () { &atomic_add_32;}' unless defined(&atomic_add_int);
    eval 'sub atomic_clear_int () { &atomic_clear_32;}' unless defined(&atomic_clear_int);
    eval 'sub atomic_cmpset_int () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_int);
    eval 'sub atomic_fcmpset_int () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_int);
    eval 'sub atomic_fetchadd_int () { &atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_int);
    eval 'sub atomic_readandclear_int () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_int);
    eval 'sub atomic_set_int () { &atomic_set_32;}' unless defined(&atomic_set_int);
    eval 'sub atomic_subtract_int () { &atomic_subtract_32;}' unless defined(&atomic_subtract_int);
    eval 'sub atomic_load_acq_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &ret;  &ret = *$p;  &fence(); ( &ret); });
    }' unless defined(&atomic_load_acq_32);
    eval 'sub atomic_store_rel_32 {
        my($p,$val) = @_;
	    eval q({  &fence(); *$p = $val; });
    }' unless defined(&atomic_store_rel_32);
    eval 'sub atomic_add_acq_int () { &atomic_add_acq_32;}' unless defined(&atomic_add_acq_int);
    eval 'sub atomic_clear_acq_int () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_int);
    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_int);
    eval 'sub atomic_fcmpset_acq_int () { &atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_int);
    eval 'sub atomic_load_acq_int () { &atomic_load_acq_32;}' unless defined(&atomic_load_acq_int);
    eval 'sub atomic_set_acq_int () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_int);
    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_int);
    eval 'sub atomic_add_rel_int () { &atomic_add_rel_32;}' unless defined(&atomic_add_rel_int);
    eval 'sub atomic_clear_rel_int () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_int);
    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_int);
    eval 'sub atomic_fcmpset_rel_int () { &atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_int);
    eval 'sub atomic_set_rel_int () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_int);
    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_int);
    eval 'sub atomic_store_rel_int () { &atomic_store_rel_32;}' unless defined(&atomic_store_rel_int);
    eval 'sub atomic_add_64 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoadd.d zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); });
    }' unless defined(&atomic_add_64);
    eval 'sub atomic_subtract_64 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoadd.d zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" (-$val) : \\"memory\\"); });
    }' unless defined(&atomic_subtract_64);
    eval 'sub atomic_set_64 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoor.d zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); });
    }' unless defined(&atomic_set_64);
    eval 'sub atomic_clear_64 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile(\\"amoand.d zero, %1, %0\\" : \\"+A\\" (*$p) : \\"r\\" (~$val) : \\"memory\\"); });
    }' unless defined(&atomic_clear_64);
    eval 'sub atomic_cmpset_64 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint64_t  &tmp; \'int\'  &res;  &res = 0;  &__asm  &__volatile( \\"0:\\" \\"li   %1, 1\\\\n\\" \\"lr.d %0, %2\\\\n\\" \\"bne  %0, %z3, 1f\\\\n\\" \\"sc.d %1, %z4, %2\\\\n\\" \\"bnez %1, 0b\\\\n\\" \\"1:\\" : \\"=&r\\" ( &tmp), \\"=&r\\" ( &res), \\"+A\\" (*$p) : \\"rJ\\" ($cmpval), \\"rJ\\" ($newval) : \\"memory\\"); (! &res); });
    }' unless defined(&atomic_cmpset_64);
    eval 'sub atomic_fcmpset_64 {
        my($p,$cmpval,$newval) = @_;
	    eval q({  &uint64_t  &tmp; \'int\'  &res;  &res = 0;  &__asm  &__volatile( \\"0:\\" \\"li   %1, 1\\\\n\\" \\"lr.d %0, %2\\\\n\\" \\"bne  %0, %z4, 1f\\\\n\\" \\"sc.d %1, %z5, %2\\\\n\\" \\"j 2f\\\\n\\" \\"1:\\" \\"sd   %0, %3\\\\n\\" \\"2:\\" : \\"=&r\\" ( &tmp), \\"=&r\\" ( &res), \\"+A\\" (*$p), \\"+A\\" (*$cmpval) : \\"rJ\\" (*$cmpval), \\"rJ\\" ($newval) : \\"memory\\"); (! &res); });
    }' unless defined(&atomic_fcmpset_64);
    eval 'sub atomic_fetchadd_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &ret;  &__asm  &__volatile(\\"amoadd.d %0, %2, %1\\" : \\"=&r\\" ( &ret), \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_fetchadd_64);
    eval 'sub atomic_readandclear_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret;  &uint64_t  &val;  &val = 0;  &__asm  &__volatile(\\"amoswap.d %0, %2, %1\\" : \\"=&r\\"( &ret), \\"+A\\" (*$p) : \\"r\\" ( &val) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_readandclear_64);
    eval 'sub atomic_swap_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &old;  &__asm  &__volatile(\\"amoswap.w %0, %2, %1\\" : \\"=&r\\"( &old), \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); ( &old); });
    }' unless defined(&atomic_swap_32);
    eval 'sub atomic_swap_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &old;  &__asm  &__volatile(\\"amoswap.d %0, %2, %1\\" : \\"=&r\\"( &old), \\"+A\\" (*$p) : \\"r\\" ($val) : \\"memory\\"); ( &old); });
    }' unless defined(&atomic_swap_64);
    eval 'sub atomic_swap_int () { &atomic_swap_32;}' unless defined(&atomic_swap_int);
    eval 'sub atomic_add_long () { &atomic_add_64;}' unless defined(&atomic_add_long);
    eval 'sub atomic_clear_long () { &atomic_clear_64;}' unless defined(&atomic_clear_long);
    eval 'sub atomic_cmpset_long () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_fcmpset_long () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_long);
    eval 'sub atomic_fetchadd_long () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_readandclear_long () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_set_long () { &atomic_set_64;}' unless defined(&atomic_set_long);
    eval 'sub atomic_subtract_long () { &atomic_subtract_64;}' unless defined(&atomic_subtract_long);
    eval 'sub atomic_swap_long () { &atomic_swap_64;}' unless defined(&atomic_swap_long);
    eval 'sub atomic_add_ptr () { &atomic_add_64;}' unless defined(&atomic_add_ptr);
    eval 'sub atomic_clear_ptr () { &atomic_clear_64;}' unless defined(&atomic_clear_ptr);
    eval 'sub atomic_cmpset_ptr () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_ptr);
    eval 'sub atomic_fcmpset_ptr () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_ptr);
    eval 'sub atomic_fetchadd_ptr () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_ptr);
    eval 'sub atomic_readandclear_ptr () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_ptr);
    eval 'sub atomic_set_ptr () { &atomic_set_64;}' unless defined(&atomic_set_ptr);
    eval 'sub atomic_subtract_ptr () { &atomic_subtract_64;}' unless defined(&atomic_subtract_ptr);
    eval 'sub atomic_swap_ptr () { &atomic_swap_64;}' unless defined(&atomic_swap_ptr);
    eval 'sub atomic_load_acq_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret;  &ret = *$p;  &fence(); ( &ret); });
    }' unless defined(&atomic_load_acq_64);
    eval 'sub atomic_store_rel_64 {
        my($p,$val) = @_;
	    eval q({  &fence(); *$p = $val; });
    }' unless defined(&atomic_store_rel_64);
    eval 'sub atomic_add_acq_long () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_long);
    eval 'sub atomic_clear_acq_long () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_long);
    eval 'sub atomic_cmpset_acq_long () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_fcmpset_acq_long () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_long);
    eval 'sub atomic_load_acq_long () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_long);
    eval 'sub atomic_set_acq_long () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_long);
    eval 'sub atomic_subtract_acq_long () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_long);
    eval 'sub atomic_add_acq_ptr () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_ptr);
    eval 'sub atomic_clear_acq_ptr () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_ptr);
    eval 'sub atomic_cmpset_acq_ptr () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_ptr);
    eval 'sub atomic_fcmpset_acq_ptr () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_ptr);
    eval 'sub atomic_load_acq_ptr () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_ptr);
    eval 'sub atomic_set_acq_ptr () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_ptr);
    eval 'sub atomic_subtract_acq_ptr () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_ptr);
    undef(&ATOMIC_ACQ_REL) if defined(&ATOMIC_ACQ_REL);
    eval 'sub atomic_thread_fence_acq {
        my($void) = @_;
	    eval q({  &fence(); });
    }' unless defined(&atomic_thread_fence_acq);
    eval 'sub atomic_thread_fence_rel {
        my($void) = @_;
	    eval q({  &fence(); });
    }' unless defined(&atomic_thread_fence_rel);
    eval 'sub atomic_thread_fence_acq_rel {
        my($void) = @_;
	    eval q({  &fence(); });
    }' unless defined(&atomic_thread_fence_acq_rel);
    eval 'sub atomic_thread_fence_seq_cst {
        my($void) = @_;
	    eval q({  &fence(); });
    }' unless defined(&atomic_thread_fence_seq_cst);
    eval 'sub atomic_add_rel_long () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_clear_rel_long () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_add_rel_long () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_clear_rel_long () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_cmpset_rel_long () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_fcmpset_rel_long () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_long);
    eval 'sub atomic_set_rel_long () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_long);
    eval 'sub atomic_subtract_rel_long () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_long);
    eval 'sub atomic_store_rel_long () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_long);
    eval 'sub atomic_add_rel_ptr () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_ptr);
    eval 'sub atomic_clear_rel_ptr () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_ptr);
    eval 'sub atomic_cmpset_rel_ptr () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_ptr);
    eval 'sub atomic_fcmpset_rel_ptr () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_ptr);
    eval 'sub atomic_set_rel_ptr () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_ptr);
    eval 'sub atomic_subtract_rel_ptr () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_ptr);
    eval 'sub atomic_store_rel_ptr () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_ptr);
    require 'sys/_atomic_subword.ph';
}
1;
