require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPU_H_)) {
    eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    require 'machine/frame.ph';
    eval 'sub TRAPF_PC {
        my($tfp) = @_;
	    eval q((($tfp)-> &tf_sepc));
    }' unless defined(&TRAPF_PC);
    eval 'sub TRAPF_USERMODE {
        my($tfp) = @_;
	    eval q(((($tfp)-> &tf_sstatus &  &SSTATUS_SPP) == 0));
    }' unless defined(&TRAPF_USERMODE);
    eval 'sub cpu_getstack {
        my($td) = @_;
	    eval q((($td)-> ($td_frame->{tf_sp})));
    }' unless defined(&cpu_getstack);
    eval 'sub cpu_setstack {
        my($td, $sp) = @_;
	    eval q((($td)-> ($td_frame->{tf_sp}) = ($sp)));
    }' unless defined(&cpu_setstack);
    eval 'sub cpu_spinwait () {
        eval q();
    }' unless defined(&cpu_spinwait);
    eval 'sub cpu_lock_delay () {
        eval q( &DELAY(1));
    }' unless defined(&cpu_lock_delay);
    if(defined(&_KERNEL)) {
	eval 'sub MVENDORID_UNIMPL () {0x;}' unless defined(&MVENDORID_UNIMPL);
	eval 'sub MVENDORID_SIFIVE () {0x489;}' unless defined(&MVENDORID_SIFIVE);
	eval 'sub MVENDORID_THEAD () {0x5b7;}' unless defined(&MVENDORID_THEAD);
	eval 'sub MARCHID_UNIMPL () {0x;}' unless defined(&MARCHID_UNIMPL);
	eval 'sub MARCHID_MSB () {(1 << ( &XLEN - 1));}' unless defined(&MARCHID_MSB);
	eval 'sub MARCHID_OPENSOURCE {
	    my($v) = @_;
    	    eval q(($v));
	}' unless defined(&MARCHID_OPENSOURCE);
	eval 'sub MARCHID_COMMERCIAL {
	    my($v) = @_;
    	    eval q(( &MARCHID_MSB | ($v)));
	}' unless defined(&MARCHID_COMMERCIAL);
	eval 'sub MARCHID_IS_OPENSOURCE {
	    my($m) = @_;
    	    eval q(((($m) &  &MARCHID_MSB) == 0));
	}' unless defined(&MARCHID_IS_OPENSOURCE);
	eval 'sub MARCHID_UCB_ROCKET () { &MARCHID_OPENSOURCE(1);}' unless defined(&MARCHID_UCB_ROCKET);
	eval 'sub MARCHID_UCB_BOOM () { &MARCHID_OPENSOURCE(2);}' unless defined(&MARCHID_UCB_BOOM);
	eval 'sub MARCHID_UCB_SPIKE () { &MARCHID_OPENSOURCE(5);}' unless defined(&MARCHID_UCB_SPIKE);
	eval 'sub MARCHID_UCAM_RVBS () { &MARCHID_OPENSOURCE(10);}' unless defined(&MARCHID_UCAM_RVBS);
	eval 'sub MARCHID_SIFIVE_U7 () { &MARCHID_COMMERCIAL(7);}' unless defined(&MARCHID_SIFIVE_U7);
	eval 'sub MMU_SV39 () {0x1;}' unless defined(&MMU_SV39);
	eval 'sub MMU_SV48 () {0x2;}' unless defined(&MMU_SV48);
	eval 'sub MMU_SV57 () {0x4;}' unless defined(&MMU_SV57);
	eval 'sub get_cyclecount {
	    my($void) = @_;
    	    eval q({ ( &rdcycle()); });
	}' unless defined(&get_cyclecount);
    }
}
1;
