require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPUFUNC_H_)) {
    eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
    eval 'sub breakpoint {
        my($void) = @_;
	    eval q({  &__asm(\\"ebreak\\"); });
    }' unless defined(&breakpoint);
    if(defined(&_KERNEL)) {
	require 'machine/riscvreg.ph';
	eval 'sub intr_disable {
	    my($void) = @_;
    	    eval q({  &uint64_t  &ret;  &__asm  &__volatile( \\"csrrci %0, sstatus, %1\\" : \\"=&r\\" ( &ret) : \\"i\\" ( &SSTATUS_SIE) ); ( &ret & ( &SSTATUS_SIE)); });
	}' unless defined(&intr_disable);
	eval 'sub intr_restore {
	    my($s) = @_;
    	    eval q({  &__asm  &__volatile( \\"csrs sstatus, %0\\" :: \\"r\\" ($s) ); });
	}' unless defined(&intr_restore);
	eval 'sub intr_enable {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile( \\"csrsi sstatus, %0\\" :: \\"i\\" ( &SSTATUS_SIE) ); });
	}' unless defined(&intr_enable);
	eval 'sub sfence_vma {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"sfence.vma\\" ::: \\"memory\\"); });
	}' unless defined(&sfence_vma);
	eval 'sub sfence_vma_page {
	    my($addr) = @_;
    	    eval q({  &__asm  &__volatile(\\"sfence.vma %0\\" :: \\"r\\" ($addr) : \\"memory\\"); });
	}' unless defined(&sfence_vma_page);
	eval 'sub rdcycle () {
	    eval q( &csr_read64( &cycle));
	}' unless defined(&rdcycle);
	eval 'sub rdtime () {
	    eval q( &csr_read64( &time));
	}' unless defined(&rdtime);
	eval 'sub rdinstret () {
	    eval q( &csr_read64( &instret));
	}' unless defined(&rdinstret);
	eval 'sub rdhpmcounter {
	    my($n) = @_;
    	    eval q( &csr_read64( &hpmcounter$n));
	}' unless defined(&rdhpmcounter);
	eval 'sub cpu_dcache_wbinv_range {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_dcache_wbinv_range);
	eval 'sub cpu_dcache_inv_range {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_dcache_inv_range);
	eval 'sub cpu_dcache_wb_range {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_dcache_wb_range);
	eval 'sub cpu_idcache_wbinv_range {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_idcache_wbinv_range);
	eval 'sub cpu_icache_sync_range {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_icache_sync_range);
	eval 'sub cpu_icache_sync_range_checked {
	    my($a, $s) = @_;
    	    eval q();
	}' unless defined(&cpu_icache_sync_range_checked);
	eval 'sub cpufunc_nullop () {
	    eval q( &riscv_nullop());
	}' unless defined(&cpufunc_nullop);
    }
}
1;
