require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_DB_MACHDEP_H_)) {
    eval 'sub _MACHINE_DB_MACHDEP_H_ () {1;}' unless defined(&_MACHINE_DB_MACHDEP_H_);
    require 'machine/riscvreg.ph';
    require 'machine/frame.ph';
    require 'machine/trap.ph';
    eval 'sub T_BREAKPOINT () {( &SCAUSE_BREAKPOINT);}' unless defined(&T_BREAKPOINT);
    eval 'sub T_WATCHPOINT () {(0);}' unless defined(&T_WATCHPOINT);
    eval 'sub PC_REGS () {
        eval q((( &db_addr_t) ($kdb_frame->{tf_sepc})));
    }' unless defined(&PC_REGS);
    eval 'sub BKPT_INST () {(0x100073);}' unless defined(&BKPT_INST);
    eval 'sub BKPT_SIZE () {( &INSN_SIZE);}' unless defined(&BKPT_SIZE);
    eval 'sub BKPT_SET {
        my($inst) = @_;
	    eval q(( &BKPT_INST));
    }' unless defined(&BKPT_SET);
    eval 'sub BKPT_SKIP () { &do {  &uint32_t  &_instr;  &_instr =  &db_get_value( &PC_REGS(), $sizeof{ &uint32_t},  &FALSE);  &if (( &_instr & 0x3) == 0x3)  ($kdb_frame->{tf_sepc}) += 4;  &else  ($kdb_frame->{tf_sepc}) += 2; }  &while (0);}' unless defined(&BKPT_SKIP);
    eval 'sub db_clear_single_step () { &kdb_cpu_clear_singlestep;}' unless defined(&db_clear_single_step);
    eval 'sub db_set_single_step () { &kdb_cpu_set_singlestep;}' unless defined(&db_set_single_step);
    eval 'sub IS_BREAKPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_BREAKPOINT));
    }' unless defined(&IS_BREAKPOINT_TRAP);
    eval 'sub IS_WATCHPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(($type ==  &T_WATCHPOINT));
    }' unless defined(&IS_WATCHPOINT_TRAP);
    eval 'sub inst_trap_return {
        my($ins) = @_;
	    eval q(($ins == 0x10000073));
    }' unless defined(&inst_trap_return);
    eval 'sub inst_return {
        my($ins) = @_;
	    eval q(($ins == 0x8067));
    }' unless defined(&inst_return);
    eval 'sub inst_call {
        my($ins) = @_;
	    eval q(((($ins) & 0x7f) == 111|| (($ins) & 0x7f) == 103));
    }' unless defined(&inst_call);
    eval 'sub inst_load {
        my($ins) = @_;
	    eval q(({  &uint32_t  &tmp_instr =  &db_get_value( &PC_REGS(), $sizeof{ &uint32_t},  &FALSE);  &is_load_instr( &tmp_instr); }));
    }' unless defined(&inst_load);
    eval 'sub inst_store {
        my($ins) = @_;
	    eval q(({  &uint32_t  &tmp_instr =  &db_get_value( &PC_REGS(), $sizeof{ &uint32_t},  &FALSE);  &is_store_instr( &tmp_instr); }));
    }' unless defined(&inst_store);
    eval 'sub is_load_instr {
        my($ins) = @_;
	    eval q(((($ins) & 0x7f) == 3));
    }' unless defined(&is_load_instr);
    eval 'sub is_store_instr {
        my($ins) = @_;
	    eval q(((($ins) & 0x7f) == 35));
    }' unless defined(&is_store_instr);
    eval 'sub next_instr_address {
        my($pc, $bd) = @_;
	    eval q((($bd) ? ($pc) : (($pc) + 4)));
    }' unless defined(&next_instr_address);
    eval 'sub DB_ELFSIZE () {64;}' unless defined(&DB_ELFSIZE);
}
1;
