require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_RISCVREG_H_)) {
    eval 'sub _MACHINE_RISCVREG_H_ () {1;}' unless defined(&_MACHINE_RISCVREG_H_);
    eval 'sub SCAUSE_INTR () {(1 << 63);}' unless defined(&SCAUSE_INTR);
    eval 'sub SCAUSE_CODE () {(~ &SCAUSE_INTR);}' unless defined(&SCAUSE_CODE);
    eval 'sub SCAUSE_INST_MISALIGNED () {0;}' unless defined(&SCAUSE_INST_MISALIGNED);
    eval 'sub SCAUSE_INST_ACCESS_FAULT () {1;}' unless defined(&SCAUSE_INST_ACCESS_FAULT);
    eval 'sub SCAUSE_ILLEGAL_INSTRUCTION () {2;}' unless defined(&SCAUSE_ILLEGAL_INSTRUCTION);
    eval 'sub SCAUSE_BREAKPOINT () {3;}' unless defined(&SCAUSE_BREAKPOINT);
    eval 'sub SCAUSE_LOAD_MISALIGNED () {4;}' unless defined(&SCAUSE_LOAD_MISALIGNED);
    eval 'sub SCAUSE_LOAD_ACCESS_FAULT () {5;}' unless defined(&SCAUSE_LOAD_ACCESS_FAULT);
    eval 'sub SCAUSE_STORE_MISALIGNED () {6;}' unless defined(&SCAUSE_STORE_MISALIGNED);
    eval 'sub SCAUSE_STORE_ACCESS_FAULT () {7;}' unless defined(&SCAUSE_STORE_ACCESS_FAULT);
    eval 'sub SCAUSE_ECALL_USER () {8;}' unless defined(&SCAUSE_ECALL_USER);
    eval 'sub SCAUSE_ECALL_SUPERVISOR () {9;}' unless defined(&SCAUSE_ECALL_SUPERVISOR);
    eval 'sub SCAUSE_INST_PAGE_FAULT () {12;}' unless defined(&SCAUSE_INST_PAGE_FAULT);
    eval 'sub SCAUSE_LOAD_PAGE_FAULT () {13;}' unless defined(&SCAUSE_LOAD_PAGE_FAULT);
    eval 'sub SCAUSE_STORE_PAGE_FAULT () {15;}' unless defined(&SCAUSE_STORE_PAGE_FAULT);
    eval 'sub SSTATUS_UIE () {(1<< 0);}' unless defined(&SSTATUS_UIE);
    eval 'sub SSTATUS_SIE () {(1<< 1);}' unless defined(&SSTATUS_SIE);
    eval 'sub SSTATUS_UPIE () {(1<< 4);}' unless defined(&SSTATUS_UPIE);
    eval 'sub SSTATUS_SPIE () {(1<< 5);}' unless defined(&SSTATUS_SPIE);
    eval 'sub SSTATUS_SPIE_SHIFT () {5;}' unless defined(&SSTATUS_SPIE_SHIFT);
    eval 'sub SSTATUS_SPP () {(1<< 8);}' unless defined(&SSTATUS_SPP);
    eval 'sub SSTATUS_SPP_SHIFT () {8;}' unless defined(&SSTATUS_SPP_SHIFT);
    eval 'sub SSTATUS_FS_SHIFT () {13;}' unless defined(&SSTATUS_FS_SHIFT);
    eval 'sub SSTATUS_FS_OFF () {(0x <<  &SSTATUS_FS_SHIFT);}' unless defined(&SSTATUS_FS_OFF);
    eval 'sub SSTATUS_FS_INITIAL () {(0x1 <<  &SSTATUS_FS_SHIFT);}' unless defined(&SSTATUS_FS_INITIAL);
    eval 'sub SSTATUS_FS_CLEAN () {(0x2 <<  &SSTATUS_FS_SHIFT);}' unless defined(&SSTATUS_FS_CLEAN);
    eval 'sub SSTATUS_FS_DIRTY () {(0x3 <<  &SSTATUS_FS_SHIFT);}' unless defined(&SSTATUS_FS_DIRTY);
    eval 'sub SSTATUS_FS_MASK () {(0x3 <<  &SSTATUS_FS_SHIFT);}' unless defined(&SSTATUS_FS_MASK);
    eval 'sub SSTATUS_XS_SHIFT () {15;}' unless defined(&SSTATUS_XS_SHIFT);
    eval 'sub SSTATUS_XS_MASK () {(0x3 <<  &SSTATUS_XS_SHIFT);}' unless defined(&SSTATUS_XS_MASK);
    eval 'sub SSTATUS_SUM () {(1<< 18);}' unless defined(&SSTATUS_SUM);
    if((defined(&__riscv_xlen) ? &__riscv_xlen : undef) == 64) {
	eval 'sub SSTATUS_SD () {(1 << 63);}' unless defined(&SSTATUS_SD);
    } else {
	eval 'sub SSTATUS_SD () {(1<< 31);}' unless defined(&SSTATUS_SD);
    }
    eval 'sub MSTATUS_UIE () {(1<< 0);}' unless defined(&MSTATUS_UIE);
    eval 'sub MSTATUS_SIE () {(1<< 1);}' unless defined(&MSTATUS_SIE);
    eval 'sub MSTATUS_HIE () {(1<< 2);}' unless defined(&MSTATUS_HIE);
    eval 'sub MSTATUS_MIE () {(1<< 3);}' unless defined(&MSTATUS_MIE);
    eval 'sub MSTATUS_UPIE () {(1<< 4);}' unless defined(&MSTATUS_UPIE);
    eval 'sub MSTATUS_SPIE () {(1<< 5);}' unless defined(&MSTATUS_SPIE);
    eval 'sub MSTATUS_SPIE_SHIFT () {5;}' unless defined(&MSTATUS_SPIE_SHIFT);
    eval 'sub MSTATUS_HPIE () {(1<< 6);}' unless defined(&MSTATUS_HPIE);
    eval 'sub MSTATUS_MPIE () {(1<< 7);}' unless defined(&MSTATUS_MPIE);
    eval 'sub MSTATUS_MPIE_SHIFT () {7;}' unless defined(&MSTATUS_MPIE_SHIFT);
    eval 'sub MSTATUS_SPP () {(1<< 8);}' unless defined(&MSTATUS_SPP);
    eval 'sub MSTATUS_SPP_SHIFT () {8;}' unless defined(&MSTATUS_SPP_SHIFT);
    eval 'sub MSTATUS_HPP_MASK () {0x3;}' unless defined(&MSTATUS_HPP_MASK);
    eval 'sub MSTATUS_HPP_SHIFT () {9;}' unless defined(&MSTATUS_HPP_SHIFT);
    eval 'sub MSTATUS_MPP_MASK () {0x3;}' unless defined(&MSTATUS_MPP_MASK);
    eval 'sub MSTATUS_MPP_SHIFT () {11;}' unless defined(&MSTATUS_MPP_SHIFT);
    eval 'sub MSTATUS_FS_MASK () {0x3;}' unless defined(&MSTATUS_FS_MASK);
    eval 'sub MSTATUS_FS_SHIFT () {13;}' unless defined(&MSTATUS_FS_SHIFT);
    eval 'sub MSTATUS_XS_MASK () {0x3;}' unless defined(&MSTATUS_XS_MASK);
    eval 'sub MSTATUS_XS_SHIFT () {15;}' unless defined(&MSTATUS_XS_SHIFT);
    eval 'sub MSTATUS_MPRV () {(1<< 17);}' unless defined(&MSTATUS_MPRV);
    eval 'sub MSTATUS_PUM () {(1<< 18);}' unless defined(&MSTATUS_PUM);
    eval 'sub MSTATUS_VM_MASK () {0x1f;}' unless defined(&MSTATUS_VM_MASK);
    eval 'sub MSTATUS_VM_SHIFT () {24;}' unless defined(&MSTATUS_VM_SHIFT);
    eval 'sub MSTATUS_VM_MBARE () {0;}' unless defined(&MSTATUS_VM_MBARE);
    eval 'sub MSTATUS_VM_MBB () {1;}' unless defined(&MSTATUS_VM_MBB);
    eval 'sub MSTATUS_VM_MBBID () {2;}' unless defined(&MSTATUS_VM_MBBID);
    eval 'sub MSTATUS_VM_SV32 () {8;}' unless defined(&MSTATUS_VM_SV32);
    eval 'sub MSTATUS_VM_SV39 () {9;}' unless defined(&MSTATUS_VM_SV39);
    eval 'sub MSTATUS_VM_SV48 () {10;}' unless defined(&MSTATUS_VM_SV48);
    eval 'sub MSTATUS_VM_SV57 () {11;}' unless defined(&MSTATUS_VM_SV57);
    eval 'sub MSTATUS_VM_SV64 () {12;}' unless defined(&MSTATUS_VM_SV64);
    if((defined(&__riscv_xlen) ? &__riscv_xlen : undef) == 64) {
	eval 'sub MSTATUS_SD () {(1 << 63);}' unless defined(&MSTATUS_SD);
    } else {
	eval 'sub MSTATUS_SD () {(1<< 31);}' unless defined(&MSTATUS_SD);
    }
    eval 'sub MSTATUS_PRV_U () {0;}' unless defined(&MSTATUS_PRV_U);
    eval 'sub MSTATUS_PRV_S () {1;}' unless defined(&MSTATUS_PRV_S);
    eval 'sub MSTATUS_PRV_H () {2;}' unless defined(&MSTATUS_PRV_H);
    eval 'sub MSTATUS_PRV_M () {3;}' unless defined(&MSTATUS_PRV_M);
    eval 'sub MIE_USIE () {(1<< 0);}' unless defined(&MIE_USIE);
    eval 'sub MIE_SSIE () {(1<< 1);}' unless defined(&MIE_SSIE);
    eval 'sub MIE_HSIE () {(1<< 2);}' unless defined(&MIE_HSIE);
    eval 'sub MIE_MSIE () {(1<< 3);}' unless defined(&MIE_MSIE);
    eval 'sub MIE_UTIE () {(1<< 4);}' unless defined(&MIE_UTIE);
    eval 'sub MIE_STIE () {(1<< 5);}' unless defined(&MIE_STIE);
    eval 'sub MIE_HTIE () {(1<< 6);}' unless defined(&MIE_HTIE);
    eval 'sub MIE_MTIE () {(1<< 7);}' unless defined(&MIE_MTIE);
    eval 'sub MIP_USIP () {(1<< 0);}' unless defined(&MIP_USIP);
    eval 'sub MIP_SSIP () {(1<< 1);}' unless defined(&MIP_SSIP);
    eval 'sub MIP_HSIP () {(1<< 2);}' unless defined(&MIP_HSIP);
    eval 'sub MIP_MSIP () {(1<< 3);}' unless defined(&MIP_MSIP);
    eval 'sub MIP_UTIP () {(1<< 4);}' unless defined(&MIP_UTIP);
    eval 'sub MIP_STIP () {(1<< 5);}' unless defined(&MIP_STIP);
    eval 'sub MIP_HTIP () {(1<< 6);}' unless defined(&MIP_HTIP);
    eval 'sub MIP_MTIP () {(1<< 7);}' unless defined(&MIP_MTIP);
    eval 'sub SIE_USIE () {(1<< 0);}' unless defined(&SIE_USIE);
    eval 'sub SIE_SSIE () {(1<< 1);}' unless defined(&SIE_SSIE);
    eval 'sub SIE_UTIE () {(1<< 4);}' unless defined(&SIE_UTIE);
    eval 'sub SIE_STIE () {(1<< 5);}' unless defined(&SIE_STIE);
    eval 'sub SIE_UEIE () {(1<< 8);}' unless defined(&SIE_UEIE);
    eval 'sub SIE_SEIE () {(1<< 9);}' unless defined(&SIE_SEIE);
    eval 'sub MIP_SEIP () {(1<< 9);}' unless defined(&MIP_SEIP);
    eval 'sub SIP_SSIP () {(1<< 1);}' unless defined(&SIP_SSIP);
    eval 'sub SIP_STIP () {(1<< 5);}' unless defined(&SIP_STIP);
    eval 'sub SATP_PPN_S () {0;}' unless defined(&SATP_PPN_S);
    eval 'sub SATP_PPN_M () {(0xfffffffffff <<  &SATP_PPN_S);}' unless defined(&SATP_PPN_M);
    eval 'sub SATP_ASID_S () {44;}' unless defined(&SATP_ASID_S);
    eval 'sub SATP_ASID_M () {(0xffff <<  &SATP_ASID_S);}' unless defined(&SATP_ASID_M);
    eval 'sub SATP_MODE_S () {60;}' unless defined(&SATP_MODE_S);
    eval 'sub SATP_MODE_M () {(0xf <<  &SATP_MODE_S);}' unless defined(&SATP_MODE_M);
    eval 'sub SATP_MODE_SV39 () {(8 <<  &SATP_MODE_S);}' unless defined(&SATP_MODE_SV39);
    eval 'sub SATP_MODE_SV48 () {(9 <<  &SATP_MODE_S);}' unless defined(&SATP_MODE_SV48);
    eval 'sub XLEN () { &__riscv_xlen;}' unless defined(&XLEN);
    eval 'sub XLEN_BYTES () {( &XLEN / 8);}' unless defined(&XLEN_BYTES);
    eval 'sub INSN_SIZE () {4;}' unless defined(&INSN_SIZE);
    eval 'sub INSN_C_SIZE () {2;}' unless defined(&INSN_C_SIZE);
    eval 'sub X_RA () {1;}' unless defined(&X_RA);
    eval 'sub X_SP () {2;}' unless defined(&X_SP);
    eval 'sub X_GP () {3;}' unless defined(&X_GP);
    eval 'sub X_TP () {4;}' unless defined(&X_TP);
    eval 'sub X_T0 () {5;}' unless defined(&X_T0);
    eval 'sub X_T1 () {6;}' unless defined(&X_T1);
    eval 'sub X_T2 () {7;}' unless defined(&X_T2);
    eval 'sub X_T3 () {28;}' unless defined(&X_T3);
    eval 'sub RD_SHIFT () {7;}' unless defined(&RD_SHIFT);
    eval 'sub RD_MASK () {(0x1f <<  &RD_SHIFT);}' unless defined(&RD_MASK);
    eval 'sub RS1_SHIFT () {15;}' unless defined(&RS1_SHIFT);
    eval 'sub RS1_MASK () {(0x1f <<  &RS1_SHIFT);}' unless defined(&RS1_MASK);
    eval 'sub RS1_SP () {( &X_SP <<  &RS1_SHIFT);}' unless defined(&RS1_SP);
    eval 'sub RS2_SHIFT () {20;}' unless defined(&RS2_SHIFT);
    eval 'sub RS2_MASK () {(0x1f <<  &RS2_SHIFT);}' unless defined(&RS2_MASK);
    eval 'sub RS2_RA () {( &X_RA <<  &RS2_SHIFT);}' unless defined(&RS2_RA);
    eval 'sub IMM_SHIFT () {20;}' unless defined(&IMM_SHIFT);
    eval 'sub IMM_MASK () {(0xfff <<  &IMM_SHIFT);}' unless defined(&IMM_MASK);
    eval 'sub RS2_C_SHIFT () {2;}' unless defined(&RS2_C_SHIFT);
    eval 'sub RS2_C_MASK () {(0x1f <<  &RS2_C_SHIFT);}' unless defined(&RS2_C_MASK);
    eval 'sub RS2_C_RA () {( &X_RA <<  &RS2_C_SHIFT);}' unless defined(&RS2_C_RA);
    eval 'sub CSR_ZIMM {
        my($val) = @_;
	    eval q(( &__builtin_constant_p  && (($val) < 32)));
    }' unless defined(&CSR_ZIMM);
    eval 'sub csr_swap {
        my($csr, $val) = @_;
	    eval q(({  &if ( &CSR_ZIMM($val))  &__asm  &__volatile(\\"csrrwi %0, \\" $csr \\", %1\\" : \\"=r\\" ($val) : \\"i\\" ($val));  &else  &__asm  &__volatile(\\"csrrw %0, \\" $csr \\", %1\\" : \\"=r\\" ($val) : \\"r\\" ($val)); $val; }));
    }' unless defined(&csr_swap);
    eval 'sub csr_write {
        my($csr, $val) = @_;
	    eval q(({  &if ( &CSR_ZIMM($val))  &__asm  &__volatile(\\"csrwi \\" $csr \\", %0\\" :: \\"i\\" ($val));  &else  &__asm  &__volatile(\\"csrw \\" $csr \\", %0\\" :: \\"r\\" ($val)); }));
    }' unless defined(&csr_write);
    eval 'sub csr_set {
        my($csr, $val) = @_;
	    eval q(({  &if ( &CSR_ZIMM($val))  &__asm  &__volatile(\\"csrsi \\" $csr \\", %0\\" :: \\"i\\" ($val));  &else  &__asm  &__volatile(\\"csrs \\" $csr \\", %0\\" :: \\"r\\" ($val)); }));
    }' unless defined(&csr_set);
    eval 'sub csr_clear {
        my($csr, $val) = @_;
	    eval q(({  &if ( &CSR_ZIMM($val))  &__asm  &__volatile(\\"csrci \\" $csr \\", %0\\" :: \\"i\\" ($val));  &else  &__asm  &__volatile(\\"csrc \\" $csr \\", %0\\" :: \\"r\\" ($val)); }));
    }' unless defined(&csr_clear);
    eval 'sub csr_read {
        my($csr) = @_;
	    eval q(({ \'u_long val\';  &__asm  &__volatile(\\"csrr %0, \\" $csr : \\"=r\\" ( &val));  &val; }));
    }' unless defined(&csr_read);
    if((defined(&__riscv_xlen) ? &__riscv_xlen : undef) == 32) {
	eval 'sub csr_read64 {
	    my($csr) = @_;
    	    eval q(({  &uint64_t  &val;  &uint32_t  &high,  &low;  &__asm  &__volatile(\\"1: \\" \\"csrr t0, \\" $csr \\"h\\\\n\\" \\"csrr %0, \\" $csr \\"\\\\n\\" \\"csrr %1, \\" $csr \\"h\\\\n\\" \\"bne t0, %1, 1b\\" : \\"=r\\" ( &low), \\"=r\\" ( &high) : : \\"t0\\");  &val = ( &low | (( &uint64_t) &high << 32));  &val; }));
	}' unless defined(&csr_read64);
    } else {
	eval 'sub csr_read64 {
	    my($csr) = @_;
    	    eval q((( &uint64_t) &csr_read($csr)));
	}' unless defined(&csr_read64);
    }
}
1;
